%define Werror_cflags %nil
# Modules always contain just 32-bit code
%define _libdir %{_exec_prefix}/lib
%ifarch	x86_64
# 64bit intel machines use 32bit boot loader
# (We cannot just redefine _target_cpu, as we'd get i386.rpm packages)
%global _target_platform i386-%{_vendor}-%{_target_os}%{?_gnu}
%global efi_arch x86_64-efi
%else
%global efi_arch i386-efi
%endif

%global pc_arch i386-pc

%global tarversion 2.06
%define uf_version 14.0.01 
Name:		grub2
Version:	2.06.0
Release:	%mkrel 6
Epoch:		1
Summary:	Boot-loader with support for Linux, Multiboot and more
Group:		System/Kernel and hardware
License:	GPLv3+ and GPLv2
URL:		http://www.gnu.org/software/grub/

Source0:	ftp://ftp.gnu.org/gnu/grub/grub-%{tarversion}.tar.xz
Source2:	grub.default.ufficiozero
Source4:	https://ftp.gnu.org/gnu/unifont/unifont-%{uf_version}/unifont-%{uf_version}.pcf.gz
Source5:	grub2.filter
Source6:	grub2.script
Source7:    grub2-check-default.sh

Patch1:         rename-grub-info-file-to-grub2.patch
Patch2:         grub2-linux.patch
Patch4:         info-dir-entry.patch
Patch6:         grub2-iterate-and-hook-for-extended-partition.patch
Patch8:         grub2-ppc-terminfo.patch
Patch9:         grub2-GRUB_CMDLINE_LINUX_RECOVERY-for-recovery-mode.patch
Patch10:        grub2-fix-error-terminal-gfxterm-isn-t-found.patch
Patch12:        grub2-fix-menu-in-xen-host-server.patch
Patch15:        not-display-menu-when-boot-once.patch
Patch17:        grub2-pass-corret-root-for-nfsroot.patch
Patch19:        grub2-efi-HP-workaround.patch
Patch21:        grub2-secureboot-add-linuxefi.patch
Patch22:        grub2-secureboot-use-linuxefi-on-uefi.patch
Patch23:        grub2-secureboot-no-insmod-on-sb.patch
Patch24:        grub2-secureboot-provide-linuxefi-config.patch
Patch25:        grub2-secureboot-chainloader.patch
Patch26:        grub2-secureboot-use-linuxefi-on-uefi-in-os-prober.patch
Patch27:        grub2-linuxefi-fix-boot-params.patch
Patch35:        grub2-linguas.sh-no-rsync.patch
Patch37:        grub2-use-Unifont-for-starfield-theme-terminal.patch
Patch38:        grub2-s390x-01-Changes-made-and-files-added-in-order-to-allow-s390x.patch
Patch39:        grub2-s390x-02-kexec-module-added-to-emu.patch
Patch40:        grub2-s390x-03-output-7-bit-ascii.patch
Patch41:        grub2-s390x-04-grub2-install.patch
Patch42:        grub2-s390x-05-grub2-mkconfig.patch
Patch46:        0046-Don-t-emit-Booting-.-message.patch
Patch53:        grub2-getroot-treat-mdadm-ddf-as-simple-device.patch
Patch56:        grub2-setup-try-fs-embed-if-mbr-gap-too-small.patch
Patch58:        grub2-xen-linux16.patch
Patch59:        grub2-efi-disable-video-cirrus-and-bochus.patch
Patch61:        grub2-vbe-blacklist-preferred-1440x900x32.patch
Patch62:        Make-grub2-mkconfig-construct-titles-that-look-like-.patch
Patch64:        grub2-grubenv-in-btrfs-header.patch
Patch65:        grub2-mkconfig-aarch64.patch
Patch70:        grub2-default-distributor.patch
Patch71:        grub2-menu-unrestricted.patch
Patch72:        grub2-mkconfig-arm.patch
Patch75:        grub2-s390x-06-loadparm.patch
Patch76:        grub2-s390x-07-add-image-param-for-zipl-setup.patch
Patch77:        grub2-s390x-08-workaround-part-to-disk.patch
Patch78:        grub2-commands-introduce-read_file-subcommand.patch
Patch79:        grub2-efi-chainload-harder.patch
Patch80:        grub2-emu-4-all.patch
Patch81:        grub2-lvm-allocate-metadata-buffer-from-raw-contents.patch
Patch82:        grub2-diskfilter-support-pv-without-metadatacopies.patch
Patch84:        grub2-s390x-09-improve-zipl-setup.patch
Patch85:        grub2-getroot-scan-disk-pv.patch
Patch92:        grub2-util-30_os-prober-multiple-initrd.patch
Patch93:        grub2-getroot-support-nvdimm.patch
Patch94:        grub2-install-fix-not-a-directory-error.patch
Patch96:        grub-install-force-journal-draining-to-ensure-data-i.patch
Patch97:        grub2-s390x-skip-zfcpdump-image.patch
# Btrfs snapshot booting related patches
Patch101:       grub2-btrfs-01-add-ability-to-boot-from-subvolumes.patch
Patch102:       grub2-btrfs-02-export-subvolume-envvars.patch
Patch103:       grub2-btrfs-03-follow_default.patch
Patch104:       grub2-btrfs-04-grub2-install.patch
Patch105:       grub2-btrfs-05-grub2-mkconfig.patch
Patch106:       grub2-btrfs-06-subvol-mount.patch
Patch107:       grub2-btrfs-07-subvol-fallback.patch
Patch108:       grub2-btrfs-08-workaround-snapshot-menu-default-entry.patch
Patch109:       grub2-btrfs-09-get-default-subvolume.patch
Patch110:       grub2-btrfs-10-config-directory.patch
Patch111:       0001-btrfs-disable-zstd-support-for-i386-pc.patch
# Support EFI xen loader
Patch120:       grub2-efi-xen-chainload.patch
Patch121:       grub2-efi-chainloader-root.patch
Patch122:       grub2-efi-xen-cmdline.patch
Patch123:       grub2-efi-xen-cfg-unquote.patch
Patch124:       grub2-efi-xen-removable.patch
# Linux root device related patches
Patch163:       grub2-zipl-setup-fix-btrfs-multipledev.patch
Patch164:       grub2-suse-remove-linux-root-param.patch
# PPC64 LE support
Patch205:       grub2-ppc64le-disable-video.patch
Patch207:       grub2-ppc64le-memory-map.patch
# PPC
Patch211:       grub2-ppc64-cas-reboot-support.patch
Patch212:       grub2-install-remove-useless-check-PReP-partition-is-empty.patch
Patch213:       grub2-Fix-incorrect-netmask-on-ppc64.patch
Patch215:       grub2-ppc64-cas-new-scope.patch
Patch218:       grub2-ppc64-cas-fix-double-free.patch
Patch233:       0001-osdep-Introduce-include-grub-osdep-major.h-and-use-i.patch
Patch234:       0002-osdep-linux-hostdisk-Use-stat-instead-of-udevadm-for.patch
Patch236:       grub2-efi_gop-avoid-low-resolution.patch
# Support HTTP Boot IPv4 and IPv6 (fate#320129)
Patch281:       0002-net-read-bracketed-ipv6-addrs-and-port-numbers.patch
Patch282:       0003-bootp-New-net_bootp6-command.patch
Patch283:       0004-efinet-UEFI-IPv6-PXE-support.patch
Patch284:       0005-grub.texi-Add-net_bootp6-doument.patch
Patch285:       0006-bootp-Add-processing-DHCPACK-packet-from-HTTP-Boot.patch
Patch286:       0007-efinet-Setting-network-from-UEFI-device-path.patch
Patch287:       0008-efinet-Setting-DNS-server-from-UEFI-protocol.patch
# TPM Support (FATE#315831)
Patch411:       0012-tpm-Build-tpm-as-module.patch
# UEFI HTTP and related network protocol support (FATE#320130)
Patch420:       0001-add-support-for-UEFI-network-protocols.patch
Patch421:       0002-AUDIT-0-http-boot-tracker-bug.patch
# check if default entry need to be corrected for updated distributor version
# and/or use fallback entry if default kernel entry removed (bsc#1065349)
Patch430:       grub2-mkconfig-default-entry-correction.patch
Patch431:       grub2-s390x-10-keep-network-at-kexec.patch
Patch432:       grub2-s390x-11-secureboot.patch
# Support for UEFI Secure Boot on AArch64 (FATE#326541)
Patch450:       grub2-secureboot-install-signed-grub.patch
Patch501:       grub2-btrfs-help-on-snapper-rollback.patch
# Improved hiDPI device support (FATE#326680)
Patch510:       grub2-video-limit-the-resolution-for-fixed-bimap-font.patch
# Support long menuentries (FATE#325760)
Patch511:       grub2-gfxmenu-support-scrolling-menu-entry-s-text.patch
Patch714:       0001-kern-mm.c-Make-grub_calloc-inline.patch
Patch716:       0002-cmdline-Provide-cmdline-functions-as-module.patch
# bsc#1172745 L3: SLES 12 SP4 - Slow boot of system after updated kernel -
# takes 45 minutes after grub to start loading kernel
Patch717:       0001-ieee1275-powerpc-implements-fibre-channel-discovery-.patch
Patch718:       0002-ieee1275-powerpc-enables-device-mapper-discovery.patch
Patch719:       0001-Unify-the-check-to-enable-btrfs-relative-path.patch
Patch721:       0001-efi-linux-provide-linux-command.patch
# Secure Boot support in GRUB on aarch64 (jsc#SLE-15864)
Patch730:       0001-Add-support-for-Linux-EFI-stub-loading-on-aarch64.patch
Patch731:       0002-arm64-make-sure-fdt-has-address-cells-and-size-cells.patch
Patch732:       0003-Make-grub_error-more-verbose.patch
Patch733:       0004-arm-arm64-loader-Better-memory-allocation-and-error-.patch
Patch735:       0006-efi-Set-image-base-address-before-jumping-to-the-PE-.patch
Patch739:       0001-Fix-build-error-in-binutils-2.36.patch
Patch740:       0001-emu-fix-executable-stack-marking.patch
Patch784:       0044-squash-kern-Add-lockdown-support.patch
Patch786:       0046-squash-verifiers-Move-verifiers-API-to-kernel-image.patch
Patch788:       0001-ieee1275-Avoiding-many-unecessary-open-close.patch
Patch789:       0001-Workaround-volatile-efi-boot-variable.patch
Patch790:       0001-30_uefi-firmware-fix-printf-format-with-null-byte.patch

#UfficioZero patches
Patch1001:     grub2-2.04-fix_duplicates_on_new_kernel_install.patch
Patch1002:     grub2-2.06-Don-t-write-messages-to-the-screen.patch
Patch1003:     grub2-2.04-detect-early-microcode-updates.patch
Patch1004:     grub2-2.04-add_failsafe-10_linux.in.patch

BuildRequires:	flex
BuildRequires:	bison
BuildRequires:	ruby
BuildRequires:	binutils
BuildRequires:  librpm-devel
BuildRequires:	glibc-static-devel
BuildRequires:	ncurses-devel
BuildRequires:	liblzo-devel
BuildRequires:	freetype2-devel
BuildRequires:	libusb1-devel
BuildRequires:	help2man
BuildRequires:	texinfo
BuildRequires:	libdevmapper-devel
BuildRequires:	fuse-devel
BuildRequires:	autogen

Requires:	os-prober
Provides:	bootloader
Provides:	grub2bootloader
Requires:	grub2-theme-ufficiozero
# Minimum version that includes /etc/os-release
Requires(pre):       UfficioZero-release

%description
This is the second version of the GRUB (Grand Unified Boot-loader), a highly
configurable and customizable boot-loader with modular architecture.
It supports a wide range of kernel formats, file systems, computer
architectures and hardware devices. It may be safely installed alongside
legacy grub.

%package efi
Summary:	Boot-loader with support for EFI
Group:		System/Kernel and hardware
Requires:	%{name}
Requires:	efibootmgr
Requires: 	efivar

%description efi
This is the second version of the GRUB (Grand Unified Boot-loader), a highly
configurable and customizable boot-loader with modular architecture.
It supports a wide range of kernel formats, file systems, computer
architectures and hardware devices. It may be safely installed alongside
legacy grub.  This subpackage provides support for EFI systems.

%prep
%setup -q -n grub-%{tarversion}
%apply_patches
mv docs/grub.texi docs/grub2.texi
cp %{SOURCE4} unifont.pcf.gz
rm -fv docs/*.info
# We create (for efi build) two copies of the sources in the Builddir
cd ..
rm -rf grub-efi-%{tarversion}
mv grub-%{tarversion} grub-efi-%{tarversion}
%setup -q -n grub-%{tarversion}
%apply_patches
mv docs/grub.texi docs/grub2.texi
cp %{SOURCE4} unifont.pcf.gz
%build
CFLAGS="-fno-strict-aliasing -fno-inline-functions-called-once "
CXXFLAGS=" "
FFLAGS=" "
export CFLAGS CXXFLAGS FFLAGS
cd ..
pushd grub-%{tarversion}
./autogen.sh
%configure2_5x TARGET_LDFLAGS=-static			\
%ifarch %arm
	  --with-platform=uboot				\
%else
	 --with-platform=pc				\
%endif
	  --disable-werror				\
	  --enable-grub-mkfont				\
	  --program-transform-name=s,grub,%{name},	\
	  --with-bootdir=/boot				\
	  --with-grubdir=/%{name}			
make %{?_smp_mflags}
popd

pushd grub-efi-%{tarversion}
./autogen.sh
%configure2_5x TARGET_LDFLAGS=-static			\
	  --with-platform=efi				\
%ifarch x86_64
	  --target=x86_64				\
%endif
	  --disable-werror				\
	  --enable-grub-mkfont				\
	  --program-transform-name=s,grub,%{name},	\
	  --with-bootdir=/boot				\
	  --with-grubdir=/%{name}			
make %{?_smp_mflags}
popd

%install
rm -rf %{buildroot}
cd ..
pushd grub-efi-%{tarversion}
%make_install
popd

pushd grub-%{tarversion}
%make_install

# Font
install -d %{buildroot}/boot/%{name}/fonts
install -D unicode.pf2 ${RPM_BUILD_ROOT}/boot/%{name}/fonts/unicode.pf2
install -d %{buildroot}/boot/%{name}/themes

# Ghost config files
install -d %{buildroot}/boot/%{name}
touch %{buildroot}/boot/%{name}/grub.cfg

# Workaround for RHL Bug 817187
install -d %{buildroot}%{_datadir}/locale/en/LC_MESSAGES
ln -s %{_datadir}/locale/en@quot/LC_MESSAGES/grub.mo %{buildroot}%{_datadir}/locale/en/LC_MESSAGES/grub.mo

cat > %{buildroot}/boot/%{name}/custom.cfg <<EOF
# Set non-graphical text/background colours
set menu_color_normal=cyan/blue
set menu_color_highlight=white/blue

# Add any extra custom menu entries in here:

EOF

# Provide 'update-grub' and update-grub2 symlink for *buntu exiles ;) 
cat > %{buildroot}%{_bindir}/update-grub <<EOF
#!/bin/sh
su --login root -c "/usr/sbin/grub2-mkconfig -o /boot/grub2/grub.cfg"

EOF
chmod +x %{buildroot}%{_bindir}/update-grub
ln -s %{_bindir}/update-grub %{buildroot}%{_bindir}/update-grub2

# Filetriggers
install -d %{buildroot}/%{_filetriggers_dir}
install -D %{SOURCE5} %{buildroot}/%{_filetriggers_dir}/%{name}.filter
install -D %{SOURCE6} %{buildroot}/%{_filetriggers_dir}/%{name}.script

# Defaults
install -m 644 -D %{SOURCE2} %{buildroot}%{_sysconfdir}/default/grub
install -m 755 -D %{SOURCE7} %{buildroot}/%{_sbindir}/grub2-check-default
# Remove "GNU/Linux" in menu selections
sed -i 's/ GNU\/Linux//' %{buildroot}%{_sysconfdir}/grub.d/10_linux

#remove startfield theme
rm -rf %{buildroot}/%{_datadir}/grub/themes/starfield


%find_lang grub

popd


%post
if [ $1 -eq 2 ]; then
      touch /boot/grub2/updtrans
fi

%post efi
if [ $1 -eq 2 ]; then
      touch /boot/grub2/updtrans-efi
fi

%posttrans 
# On update re-install grub2 to where it was installed by drakboot if possible,
# otherwise next boot may fail due to mismatched boot code.
   if [ -f /boot/grub2/updtrans ] && [ -f /boot/grub2/install.sh -a -x /usr/sbin/detectloader ] && [ "$DURING_INSTALL" != "1" ] ; then
		LOADER=$(/usr/sbin/detectloader)
		[ "$LOADER" = "GRUB2" ] && /boot/grub2/install.sh ||:
		rm -f /boot/grub2/updtrans
   fi


%posttrans efi
# On update re-install grub2 to where it was installed by drakboot if possible,
# otherwise next boot may fail due to mismatched boot code.
   if [ -f /boot/grub2/updtrans-efi ] && [ -f /boot/grub2/install.sh -a -x /usr/sbin/detectloader ] && [ "$DURING_INSTALL" != "1" ] ; then
		LOADER=$(/usr/sbin/detectloader)
		[ "$LOADER" = "GRUB2" ] && /boot/grub2/install.sh ||:
		rm -f /boot/grub2/updtrans-efi
   fi   
   

%preun
exec > /var/log/%{name}_preun.log 2>&1
# Only if uninstalling
if [ $1 -eq 0 ]; then
rm -rf /boot/%{name}/%{pc_arch}
rm -rf /boot/%{name}/locale
fi

%preun efi
exec > /var/log/%{name}_preun.log 2>&1
# Only if uninstalling
if [ $1 -eq 0 ]; then
rm -rf /boot/%{name}/%{efi_arch}
rm -rf /boot/%{name}/locale
fi

%triggerpostun efi -- %{name}-efi < 2.02
%{name}-mkconfig -o /boot/%{name}/grub.cfg

%clean
rm -rf %{buildroot}

%files
%defattr(-,root,root,-)
%{_infodir}/*
%dir %{_libdir}/grub
%dir %{_libdir}/grub/i386-pc
%dir /boot/%{name}
%dir /boot/%{name}/themes
%dir /boot/%{name}/fonts
/boot/grub2/fonts/unicode.pf2
%{_libdir}/grub/i386-pc/*
%{_bindir}/%{name}-*
%{_bindir}/update-grub
%{_bindir}/update-grub2
%{_sbindir}/%{name}-*
%{_sysconfdir}/bash_completion.d/grub
%{_sysconfdir}/grub.d/README
%{_sysconfdir}/grub.d/00_header
%{_sysconfdir}/grub.d/10_linux
%{_sysconfdir}/grub.d/20_linux_xen
%{_sysconfdir}/grub.d/20_ppc_terminfo
%{_sysconfdir}/grub.d/30_os-prober
%{_sysconfdir}/grub.d/30_uefi-firmware
%config(noreplace) %{_sysconfdir}/grub.d/40_custom
%config(noreplace) %{_sysconfdir}/grub.d/41_custom
%{_datadir}/grub
%config(noreplace) /boot/%{name}/grub.cfg
%config(noreplace) /boot/%{name}/custom.cfg
%{_mandir}/man1/%{name}-*.1*
%{_mandir}/man8/%{name}-*.8*
%{_filetriggers_dir}/%{name}.filter
%{_filetriggers_dir}/%{name}.script

#dont replace this on update
%config(noreplace) %{_sysconfdir}/default/grub

#goes in theme package
%{_datadir}/locale


%files efi
%defattr(-,root,root,-)
%dir %{_libdir}/grub
%dir %{_libdir}/grub/%{efi_arch}
%{_libdir}/grub/%{efi_arch}/*



%changelog
* Thu Nov 12 2021 adrianomorselli <dev@ufficiozero.org> 2.06.0-6ufficiozero2021
- rebuilded for ufficiozero
